'use strict';

require('babel-core/polyfill');

var _require = require('lodash');

var defaults = _require.defaults;

var GitHubApi = require('github');
var promisify = require('es6-promisify');

var contentFromFilename = require('./content-from-filename');
var updateFileWithContent = require('./update-file-with-content');

module.exports = function callee$0$0(config, callback) {
  var _config, _config$branch, branch, token, transform, force, github, content, newContent, transformedConfig, commit, _config2, push, pr, newBranch;

  return regeneratorRuntime.async(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        _config = config;
        _config$branch = _config.branch;
        branch = _config$branch === undefined ? 'master' : _config$branch;
        token = _config.token;
        transform = _config.transform;
        force = _config.force;
        context$1$0.prev = 6;
        github = config.github;

        if (!github) {
          github = new GitHubApi({
            version: '3.0.0'
          });

          github.authenticate({ type: 'oauth', token: token });
        }

        context$1$0.next = 11;
        return regeneratorRuntime.awrap(contentFromFilename(github, config));

      case 11:
        content = context$1$0.sent;
        newContent = transform(content.content);
        transformedConfig = {};

        if (typeof newContent === 'string') transformedConfig.content = newContent;else transformedConfig = newContent;

        config = defaults(transformedConfig, { sha: content.commit }, config);

        context$1$0.next = 18;
        return regeneratorRuntime.awrap(updateFileWithContent(github, config));

      case 18:
        commit = context$1$0.sent;
        _config2 = config;
        push = _config2.push;
        pr = _config2.pr;
        newBranch = _config2.newBranch;

        if (pr || push || newBranch) {
          context$1$0.next = 25;
          break;
        }

        return context$1$0.abrupt('return', callback(null, commit));

      case 25:
        if (!push) {
          context$1$0.next = 27;
          break;
        }

        return context$1$0.abrupt('return', github.gitdata.updateReference(defaults({
          ref: 'refs/heads/' + branch,
          sha: commit.sha
        }, config), callback));

      case 27:
        if (!newBranch) {
          context$1$0.next = 30;
          break;
        }

        context$1$0.next = 30;
        return regeneratorRuntime.awrap(promisify(github.gitdata[force ? 'updateReference' : 'createReference'])(defaults({
          sha: commit.sha,
          ref: 'refs/heads/' + newBranch,
          force: force
        }, config)));

      case 30:
        if (pr) {
          context$1$0.next = 32;
          break;
        }

        return context$1$0.abrupt('return', callback(null, { commit: commit }));

      case 32:

        github.pullRequests.create(defaults(pr, config, {
          base: branch,
          head: config.newBranch || commit.sha
        }), callback);
        context$1$0.next = 38;
        break;

      case 35:
        context$1$0.prev = 35;
        context$1$0.t0 = context$1$0['catch'](6);

        callback(context$1$0.t0);

      case 38:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[6, 35]]);
};